/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/*****************************************************************************/
/** \file adc1.h
**
** History:
** 
*****************************************************************************/
#ifndef __ADCB_H_
#define __ADCB_H_

#ifdef __cplusplus
extern "C"
{
#endif

/*****************************************************************************/
/* Include files */
/*****************************************************************************/
#include "CMS32F035x.h"
/*****************************************************************************/
/* Global pre-processor symbols/macros ('#define') */
/*****************************************************************************/
/*----------------------------------------------------------------------------
 **ADCB οԴ
-----------------------------------------------------------------------------*/
#define  ADCB_VREF_BG		(0x02UL<<ADCB_CON_ADCVS_Pos)   /*οԴѡBG 1.2V*/
#define  ADCB_VREF_VDD		(0x00UL)                       /*οԴѡVDD*/

/*----------------------------------------------------------------------------
 **ADCB תģʽ
-----------------------------------------------------------------------------*/
#define 	ADCB_MODE_HIGH		(0x00UL)						/*תģʽ*/
#define 	ADCB_MODE_LOW		(0x03UL<<ADCB_CON_ADMODE10_Pos)	/*͵ģʽ*/

#define 	ADCB_CONVERT_SINGLE		(0x00UL)						/*ģʽ*/
#define 	ADCB_CONVERT_CONTINUOUS		(0x01UL<<ADCB_CON_ADCMS_Pos)	/*ģʽ*/

/*----------------------------------------------------------------------------
 **ADCB ʱӷƵ
-----------------------------------------------------------------------------*/
#define 	ADCB_CLK_DIV_1		(0x00UL)			/*ADCB ʱӷƵΪ 1*/
#define 	ADCB_CLK_DIV_2		(0x01UL)			/*ADCB ʱӷƵΪ 2*/
#define 	ADCB_CLK_DIV_4		(0x02UL)			/*ADCB ʱӷƵΪ 4*/
#define 	ADCB_CLK_DIV_8		(0x03UL)			/*ADCB ʱӷƵΪ 8*/
#define 	ADCB_CLK_DIV_16		(0x04UL)			/*ADCB ʱӷƵΪ 16*/
#define 	ADCB_CLK_DIV_32		(0x05UL)			/*ADCB ʱӷƵΪ 32*/
#define 	ADCB_CLK_DIV_64		(0x06UL)			/*ADCB ʱӷƵΪ 64*/
#define 	ADCB_CLK_DIV_128	(0x07UL)			/*ADCB ʱӷƵΪ 128*/

/*----------------------------------------------------------------------------
 **ADCB ⲿѡ
-----------------------------------------------------------------------------*/
#define		ADCB_TG_EXT_FALLING			((0x0UL)|ADCB_HWTG_ADCEXTEN_Msk)			/*ⲿӲ½ش*/
#define		ADCB_TG_EXT_RISING			((0x1UL<<ADCB_HWTG_ADCEXTES_Pos)|ADCB_HWTG_ADCEXTEN_Msk)	/*ⲿӲش*/			

/*----------------------------------------------------------------------------
 **ADCB ڲԴѡ
-----------------------------------------------------------------------------*/
#define		ADCB_TG_INTNEL_ADC0				(0x0UL | ADCB_HWTG_ADCINTTGEN_Msk)		/*ڲADC0*/	
#define		ADCB_TG_INTNEL_ADCB				((0x1UL<<ADCB_HWTG_ADCINTTGSS_Pos)| ADCB_HWTG_ADCINTTGEN_Msk)	/*ڲADCB*/		
#define		ADCB_TG_INTNEL_ACMP0			((0x2UL<<ADCB_HWTG_ADCINTTGSS_Pos)| ADCB_HWTG_ADCINTTGEN_Msk)	/*ڲACMP0¼*/					
#define		ADCB_TG_INTNEL_ACMP1			((0x3UL<<ADCB_HWTG_ADCINTTGSS_Pos)| ADCB_HWTG_ADCINTTGEN_Msk)	/*ڲACMP1¼*/	
#define		ADCB_TG_INTNEL_TMR0				((0x4UL<<ADCB_HWTG_ADCINTTGSS_Pos)| ADCB_HWTG_ADCINTTGEN_Msk)	/*ڲTMR0ʹжϴ*/			
#define		ADCB_TG_INTNEL_TMR1				((0x5UL<<ADCB_HWTG_ADCINTTGSS_Pos)| ADCB_HWTG_ADCINTTGEN_Msk)	/*ڲTMR1ʹжϴ*/	
#define		ADCB_TG_INTNEL_TMR2				((0x6UL<<ADCB_HWTG_ADCINTTGSS_Pos)| ADCB_HWTG_ADCINTTGEN_Msk)	/*ڲTMR2ʹжϴ*/			
#define		ADCB_TG_INTNEL_TMR3				((0x7UL<<ADCB_HWTG_ADCINTTGSS_Pos)| ADCB_HWTG_ADCINTTGEN_Msk)	/*ڲTMR3ʹжϴ*/	

/*----------------------------------------------------------------------------
 **ADCB EPWMԴѡ
-----------------------------------------------------------------------------*/
#define		ADCB_TG_EPWM_CMP0				(0x01UL<<ADCB_HWTG_ADCPTG0EN_Pos)	/*EPWMȽ0*/
#define		ADCB_TG_EPWM_CMP1				(0x01UL<<ADCB_HWTG_ADCPTG1EN_Pos)	/*EPWMȽ1*/

#define		ADCB_TG_EPWM0_RISING			(0x1UL<<ADCB_HWTG_ADCEPWMTEN_Pos)	/*EPWM0شж*/
#define		ADCB_TG_EPWM0_FALLING			((0x1UL<<ADCB_HWTG_ADCEPWMTEN_Pos)|(0x2<<ADCB_HWTG_ADCEPWMTPS_Pos))	/*EPWM0½شж*/		
#define		ADCB_TG_EPWM0_PERIOD			((0x1UL<<ADCB_HWTG_ADCEPWMTEN_Pos)|(0x1<<ADCB_HWTG_ADCEPWMTPS_Pos))	/*EPWM0ڵ㴥ж*/	
#define		ADCB_TG_EPWM0_ZERO				((0x1UL<<ADCB_HWTG_ADCEPWMTEN_Pos)|(0x3<<ADCB_HWTG_ADCEPWMTPS_Pos))	/*EPWM0㴥ж*/
#define		ADCB_TG_EPWM1_RISING			((0x1UL<<ADCB_HWTG_ADCEPWMTEN_Pos)| (0x1<<ADCB_HWTG_ADCEPWMTSS_Pos))
#define		ADCB_TG_EPWM1_FALLING			((0x1UL<<ADCB_HWTG_ADCEPWMTEN_Pos)| (0x1<<ADCB_HWTG_ADCEPWMTSS_Pos)|(0x2<<ADCB_HWTG_ADCEPWMTPS_Pos))
#define		ADCB_TG_EPWM1_PERIOD			((0x1UL<<ADCB_HWTG_ADCEPWMTEN_Pos)| (0x1<<ADCB_HWTG_ADCEPWMTSS_Pos)|(0x1<<ADCB_HWTG_ADCEPWMTPS_Pos))
#define		ADCB_TG_EPWM1_ZERO				((0x1UL<<ADCB_HWTG_ADCEPWMTEN_Pos)| (0x1<<ADCB_HWTG_ADCEPWMTSS_Pos)|(0x3<<ADCB_HWTG_ADCEPWMTPS_Pos))
#define		ADCB_TG_EPWM2_RISING			((0x1UL<<ADCB_HWTG_ADCEPWMTEN_Pos)| (0x2<<ADCB_HWTG_ADCEPWMTSS_Pos))
#define		ADCB_TG_EPWM2_FALLING			((0x1UL<<ADCB_HWTG_ADCEPWMTEN_Pos)| (0x2<<ADCB_HWTG_ADCEPWMTSS_Pos)|(0x2<<ADCB_HWTG_ADCEPWMTPS_Pos))
#define		ADCB_TG_EPWM2_PERIOD			((0x1UL<<ADCB_HWTG_ADCEPWMTEN_Pos)| (0x2<<ADCB_HWTG_ADCEPWMTSS_Pos)|(0x1<<ADCB_HWTG_ADCEPWMTPS_Pos))
#define		ADCB_TG_EPWM2_ZERO				((0x1UL<<ADCB_HWTG_ADCEPWMTEN_Pos)| (0x2<<ADCB_HWTG_ADCEPWMTSS_Pos)|(0x3<<ADCB_HWTG_ADCEPWMTPS_Pos))
#define		ADCB_TG_EPWM3_RISING			((0x1UL<<ADCB_HWTG_ADCEPWMTEN_Pos)| (0x3<<ADCB_HWTG_ADCEPWMTSS_Pos))
#define		ADCB_TG_EPWM3_FALLING			((0x1UL<<ADCB_HWTG_ADCEPWMTEN_Pos)| (0x3<<ADCB_HWTG_ADCEPWMTSS_Pos)|(0x2<<ADCB_HWTG_ADCEPWMTPS_Pos))
#define		ADCB_TG_EPWM3_PERIOD			((0x1UL<<ADCB_HWTG_ADCEPWMTEN_Pos)| (0x3<<ADCB_HWTG_ADCEPWMTSS_Pos)|(0x1<<ADCB_HWTG_ADCEPWMTPS_Pos))
#define		ADCB_TG_EPWM3_ZERO				((0x1UL<<ADCB_HWTG_ADCEPWMTEN_Pos)| (0x3<<ADCB_HWTG_ADCEPWMTSS_Pos)|(0x3<<ADCB_HWTG_ADCEPWMTPS_Pos))

/*----------------------------------------------------------------------------
 **ADC1 ͨ
-----------------------------------------------------------------------------*/
#define		ADCB_CH_0					(0x0UL)			
#define		ADCB_CH_1					(0x1UL)	
#define		ADCB_CH_2					(0x2UL)			
#define		ADCB_CH_3					(0x3UL)			
#define		ADCB_CH_4					(0x4UL)		
#define		ADCB_CH_5					(0x5UL)			
#define		ADCB_CH_6					(0x6UL)	
#define		ADCB_CH_7					(0x7UL)			
#define		ADCB_CH_8					(0x8UL)			
#define		ADCB_CH_9					(0x9UL)		
#define		ADCB_CH_10					(0xAUL)			
#define		ADCB_CH_11					(0xBUL)	
#define		ADCB_CH_12					(0xCUL)			
#define		ADCB_CH_13					(0xDUL)			
#define		ADCB_CH_14					(0xEUL)		
#define		ADCB_CH_15					(0xFUL)			
#define		ADCB_CH_16					(0x10UL)	
#define		ADCB_CH_17					(0x11UL)			
#define		ADCB_CH_18					(0x12UL)			
#define		ADCB_CH_19					(0x13UL)


#define		ADCB_CH_0_MSK				(0x1UL)			
#define		ADCB_CH_1_MSK				(0x2UL)	
#define		ADCB_CH_2_MSK				(0x4UL)			
#define		ADCB_CH_3_MSK				(0x8UL)			
#define		ADCB_CH_4_MSK				(0x10UL)		
#define		ADCB_CH_5_MSK				(0x20UL)			
#define		ADCB_CH_6_MSK				(0x40UL)	
#define		ADCB_CH_7_MSK				(0x80UL)			
#define		ADCB_CH_8_MSK				(0x100UL)			
#define		ADCB_CH_9_MSK				(0x200UL)		
#define		ADCB_CH_10_MSK				(0x400UL)			
#define		ADCB_CH_11_MSK				(0x800UL)	
#define		ADCB_CH_12_MSK				(0x1000UL)			
#define		ADCB_CH_13_MSK				(0x2000UL)			
#define		ADCB_CH_14_MSK				(0x4000UL)		
#define		ADCB_CH_15_MSK				(0x8000UL)			
#define		ADCB_CH_16_MSK				(0x10000UL)	
#define		ADCB_CH_17_MSK				(0x20000UL)			
#define		ADCB_CH_18_MSK				(0x40000UL)			
#define		ADCB_CH_19_MSK				(0x80000UL)


/*----------------------------------------------------------------------------
 **ADC1   Ƚ
-----------------------------------------------------------------------------*/
#define		ADCB_CMP_LESS_THAN_RESULT		(0x00UL)		/*ADC <Ԥֵ*/
#define		ADCB_CMP_NOT_LESS_THAN_RESULT	(0x01UL<<ADCB_CMP_ADCCMPCOND_Pos)		/*ADC >=Ԥֵ*/

#define		ADCB_CMP0						(0x00UL)		/*ADCBȽ0*/
#define		ADCB_CMP1						(0x01UL)		/*ADCBȽ1*/
	

/*----------------------------------------------------------------------------
 **ADC1   д
-----------------------------------------------------------------------------*/
#define		ADCB_LOCK_WRITE_KEY		(0x55UL)


/*****************************************************************************
 ** \brief	ADCB_IS_BUSY
 **			ȡADCBת/б־λ
 ** \param [in] none
 ** \return  1æ   0/ת
 ** \note	 
*****************************************************************************/
#define	ADCB_IS_BUSY()		((ADCB->CON2&ADCB_CON2_ADCST_Msk)? 1:0)



/*****************************************************************************
 ** \brief	ADC1_Go
 **			ADC1ת
 ** \param [in] none
 ** \return  none
 ** \note	 
*****************************************************************************/
__STATIC_INLINE	void ADCB_Go(void)
{
	ADCB->LOCK = ADCB_LOCK_WRITE_KEY;
	ADCB->CON2 |= ADCB_CON2_ADCST_Msk;
	ADCB->LOCK = 0x00;
}

							
/*****************************************************************************/
/* Global type definitions ('typedef') */
/*****************************************************************************/


/*****************************************************************************/
/* Global variable declarations ('extern', definition in C source) */
/*****************************************************************************/


/*****************************************************************************/
/* Global function prototypes ('extern', definition in C source) */
/*****************************************************************************/

/*****************************************************************************
 ** \brief	ADCB_ConfigRunMode
 **			ADCģʽ
 ** \param [in] RunMode: (1)ADCB_MODE_HIGH
 **						 (2)ADCB_MODE_LOW
 **				ConvertMode:(1)ADCB_CONVERT_SINGLE			
 **							(2)ADCB_CONVERT_CONTINUOUS				
 **				ClkDiv :(1)ADCB_CLK_DIV_1
 **						(2)ADCB_CLK_DIV_2
 **						(3)ADCB_CLK_DIV_4
 **						(4)ADCB_CLK_DIV_8
 **						(5)ADCB_CLK_DIV_16
 **						(6)ADCB_CLK_DIV_32
 **						(7)ADCB_CLK_DIV_64
 **						(8)ADCB_CLK_DIV_128
 **				Holdtime: 5~255 		
 ** \return  none
 ** \note	
*****************************************************************************/
void ADCB_ConfigRunMode(uint32_t RunMode, uint32_t ConvertMode,uint32_t ClkDiv, uint32_t Holdtime);

/*****************************************************************************
 ** \brief	ADCB_EnableScanChannel
 **			ADCתͨ
 ** \param [in] ChannelMask: ADCB_CH_0_MSK ~ ADCB_CH_19_MSK
 ** \return  none
 ** \note	
*****************************************************************************/
void ADCB_EnableScanChannel(uint32_t ChannelMask);
/*****************************************************************************
 ** \brief	ADCB_DisableScanChannel
 **			رADCBתͨ
 ** \param [in] ChannelMask: ADCB_CH_0_MSK ~ ADCB_CH_19_MSK
 ** \return  none
 ** \note	
*****************************************************************************/
void ADCB_DisableScanChannel(uint32_t ChannelMask);

/*****************************************************************************
 ** \brief	ADCB_GetResult
 **			ȡADCBת
 ** \param [in] Channel: ADC1_CH_0 ~ ADC1_CH_19
 ** \return  12 bits Value
 ** \note	
*****************************************************************************/
uint32_t ADCB_GetResult(uint32_t Channel);

/*****************************************************************************
 ** \brief	ADCB_EnableHardwareTrigger
 **			ӲADCBת
 ** \param [in] TriggerSource: (1)ADCB_TG_EXT_FALLING
 **							(2)ADCB_TG_EXT_RISING
 **							(3)ADCB_TG_INTNEL_ADC0
 **							(4)ADCB_TG_INTNEL_ADCB
 **							(5)ADCB_TG_INTNEL_ACMP0
 **							(6)ADCB_TG_INTNEL_ACMP1
 **							(7)ADCB_TG_INTNEL_TMR0
 **							(8)ADCB_TG_INTNEL_TMR1
 **							(9)ADCB_TG_EPWM_CMP0
 **							(10)ADCB_TG_EPWM_CMP1
 **							(11)ADCB_TG_EPWM0_RISING
 **							(12)ADCB_TG_EPWM0_FALLING
 **							(13)ADCB_TG_EPWM0_PERIOD
 **							(14)ADCB_TG_EPWM0_ZERRO
 **							(15)ADCB_TG_EPWM1_RISING
 **							(16)ADCB_TG_EPWM1_FALLING
 **							(17)ADCB_TG_EPWM1_PERIOD
 **							(18)ADCB_TG_EPWM1_ZERRO
 **							(19)ADCB_TG_EPWM2_RISING
 **							(20)ADCB_TG_EPWM2_FALLING
 **							(21)ADCB_TG_EPWM2_PERIOD
 **							(22)ADCB_TG_EPWM2_ZERRO
 **							(23)ADCB_TG_EPWM3_RISING
 **							(24)ADCB_TG_EPWM3_FALLING
 **							(25)ADCB_TG_EPWM3_PERIOD
 **							(26)ADCB_TG_EPWM3_ZERRO
 **							(35)ADCB_TG_INTNEL_TMR2
 **							(36)ADCB_TG_INTNEL_TMR3	
 ** \return  none
 ** \note	
*****************************************************************************/
void ADCB_EnableHardwareTrigger(uint32_t TriggerSource);
/*****************************************************************************
 ** \brief	ADC1_DisableHardwareTrigger
 **			رӲADC1ת
 ** \param [in] TriggerSource: (1)ADCB_TG_EXT_FALLING
 **							(2)ADCB_TG_EXT_RISING
 **							(3)ADCB_TG_INTNEL_ADC0
 **							(4)ADCB_TG_INTNEL_ADCB
 **							(5)ADCB_TG_INTNEL_ACMP0
 **							(6)ADCB_TG_INTNEL_ACMP1
 **							(7)ADCB_TG_INTNEL_TMR0
 **							(8)ADCB_TG_INTNEL_TMR1
 **							(9)ADCB_TG_EPWM_CMP0
 **							(10)ADCB_TG_EPWM_CMP1
 **							(11)ADCB_TG_EPWM0_RISING
 **							(12)ADCB_TG_EPWM0_FALLING
 **							(13)ADCB_TG_EPWM0_PERIOD
 **							(14)ADCB_TG_EPWM0_ZERRO
 **							(15)ADCB_TG_EPWM1_RISING
 **							(16)ADCB_TG_EPWM1_FALLING
 **							(17)ADCB_TG_EPWM1_PERIOD
 **							(18)ADCB_TG_EPWM1_ZERRO
 **							(19)ADCB_TG_EPWM2_RISING
 **							(20)ADCB_TG_EPWM2_FALLING
 **							(21)ADCB_TG_EPWM2_PERIOD
 **							(22)ADCB_TG_EPWM2_ZERRO
 **							(23)ADCB_TG_EPWM3_RISING
 **							(24)ADCB_TG_EPWM3_FALLING
 **							(25)ADCB_TG_EPWM3_PERIOD
 **							(26)ADCB_TG_EPWM3_ZERRO
 **							(35)ADCB_TG_INTNEL_TMR2
 **							(36)ADCB_TG_INTNEL_TMR3	
 ** \return  none
 ** \note	
*****************************************************************************/
void ADCB_DisableHardwareTrigger(uint32_t TriggerSource);
/*****************************************************************************
 ** \brief	ADCB_SetTriggerDelayTime
 **			ADCB EPWMʱʱ
 ** \param [in] DelayTime: 0x00~ 0x3ff;
 ** \return  none
 ** \note  Time = (DelayTime+2)*PCLK
*****************************************************************************/
void ADCB_SetTriggerDelayTime(uint32_t DelayTime);
/*****************************************************************************
 ** \brief	ADCB_EnableEPWMTriggerChannel
 **			ʹ EPWM ADCBתͨ
 ** \param [in] ChannelMask: ADCB_CH_0_MSK ~ ADCB_CH_19_MSK
 ** \return  none
 ** \note  
*****************************************************************************/
void ADCB_EnableEPWMTriggerChannel(uint32_t ChannelMask);
/*****************************************************************************
 ** \brief	ADCB_DisableEPWMTriggerChannel
 **			ر EPWM ADCBתͨ
 ** \param [in] ChannelMask: ADCB_CH_0_MSK ~ ADCB_CH_19_MSK
 ** \return  none
 ** \note  
*****************************************************************************/
void ADCB_DisableEPWMTriggerChannel(uint32_t ChannelMask);

/*****************************************************************************
 ** \brief	ADCB_EnableEPWMCmp0TriggerChannel
 **			ʹ EPWM Ƚ0 ADCBתͨ
 ** \param [in] ChannelMask: ADCB_CH_0_MSK ~ ADCB_CH_19_MSK
 ** \return  none
 ** \note  
*****************************************************************************/
void ADCB_EnableEPWMCmp0TriggerChannel(uint32_t ChannelMask);
/*****************************************************************************
 ** \brief	ADCB_DisableEPWMCmp0TriggerChannel
 **			ر EPWM Ƚ0 ADCBתͨ
 ** \param [in] ChannelMask: ADCB_CH_0_MSK ~ ADCB_CH_19_MSK
 ** \return  none
 ** \note  
*****************************************************************************/
void ADCB_DisableEPWMCmp0TriggerChannel(uint32_t ChannelMask);

/*****************************************************************************
 ** \brief	ADCB_EnableEPWMCmp1TriggerChannel
 **			ʹ EPWM Ƚ1 ADCBתͨ
 ** \param [in] ChannelMask: ADCB_CH_0_MSK ~ ADCB_CH_19_MSK
 ** \return  none
 ** \note  
*****************************************************************************/
void ADCB_EnableEPWMCmp1TriggerChannel(uint32_t ChannelMask);
/*****************************************************************************
 ** \brief	ADCB_DisableEPWMCmp1TriggerChannel
 **			ر EPWM Ƚ1 ADCBתͨ
 ** \param [in] ChannelMask: ADCB_CH_0_MSK ~ ADCB_CH_19_MSK
 ** \return  none
 ** \note  
*****************************************************************************/
void ADCB_DisableEPWMCmp1TriggerChannel(uint32_t ChannelMask);


/*****************************************************************************
 ** \brief	ADCB_EnableCompare
 **			ADCBȽϹ
 ** \param [in] Compare : ADCB_CMP0 ADCB_CMP1
 ** \return  none
 ** \note	
*****************************************************************************/
void ADCB_EnableCompare(uint32_t Compare);
/*****************************************************************************
 ** \brief	ADCB_DisableCompare
 **			رADCBȽϹ
 ** \param [in] Compare : ADCB_CMP0 ADCB_CMP1
 ** \return  none
 ** \note	
*****************************************************************************/
void ADCB_DisableCompare(uint32_t Compare);
/*****************************************************************************
 ** \brief	ADCB_ConfigCompare
 **			ADCBȽϹ
 ** \param [in]  Compare : ADCB_CMP0 ADCB_CMP1
 **				 CmpMode:(1)ADCB_CMP_LESS_THAN_RESULT
 **						 (2)ADCB_CMP_NOT_LESS_THAN_RESULT
 **				 CmpCount: 0x00~0xf  ԤȽϴ
 **				 CmpChannel: ADCB_CH_0 ~ ADCB_CH_30
 **				 CmpData : 12 bit Ƚֵ
 ** \return  none
 ** \note	ڲADCCMPxMCNT+1ֵʱADCȽ¼
*****************************************************************************/
void ADCB_ConfigCompare(uint32_t Compare, uint32_t CmpMode, uint32_t CmpCount,  
						uint32_t CmpChannel, uint32_t CmpData);

/*****************************************************************************
 ** \brief	ADCB_GetCompareResult
 **			ȡADCBȽ
 ** \param [in] Compare : ADCB_CMP0 ADCB_CMP1
 ** \return  1 /0
 ** \note	
*****************************************************************************/
uint32_t ADCB_GetCompareResult(uint32_t Compare);


/*****************************************************************************
 ** \brief	ADCB_Start
 **			ADCB
 ** \param [in] none
 ** \return  none
 ** \note	
*****************************************************************************/
void ADCB_Start(void);
/*****************************************************************************
 ** \brief	ADCB_Stop
 **			رADCB
 ** \param [in] none
 ** \return  none
 ** \note	
*****************************************************************************/
void ADCB_Stop(void);

/*****************************************************************************
 ** \brief	ADCB_StartAdjust
 **			ADCBУ׼
 ** \param [in] none
** \return  none
 ** \note	
*****************************************************************************/
void ADCB_StartAdjust(void);

/*****************************************************************************
 ** \brief	ADCB_EnableAdjust
 **			ADCBУ׼ݵADCת
 ** \param [in] none
 ** \return   none
 ** \note	
*****************************************************************************/
void ADCB_EnableAdjust(void);
/*****************************************************************************
 ** \brief	ADCB_DisableAdjust
 **			رADCBУ׼ݵADCת
 ** \param [in] none
 ** \return  none
 ** \note	
*****************************************************************************/
void ADCB_DisableAdjust(void);


/*****************************************************************************
 ** \brief	ADCB_EnableReset
 **			λADCB
 ** \param [in] none
 ** \return  none
 ** \note	
*****************************************************************************/
void ADCB_EnableReset(void);

/*****************************************************************************
 ** \brief	ADCB_GetConvertErrorFlag
 **			ȡADCB ת־λ
 ** \param [in] none
 ** \return  1 תִ	0޴
 ** \note	
*****************************************************************************/
uint32_t ADCB_GetConvertErrorFlag(void);
/*****************************************************************************
 ** \brief	ADCB_GetAdjustErrorFlag
 **			ȡADCB У׼־λ
 ** \param [in] none
 ** \return  1 У׼ִ	0޴
 ** \note	
*****************************************************************************/
uint32_t ADCB_GetAdjustErrorFlag(void);

/*****************************************************************************
 ** \brief	ADCB_ClearConvertErrorFlag
 **			ADCB ת־λ
 ** \param [in] none
 ** \return  none
 ** \note	
*****************************************************************************/
void ADCB_ClearConvertErrorFlag(void);
/*****************************************************************************
 ** \brief	ADCB_ClearAdjustErrorFlag
 **			ADCB У׼־λ
 ** \param [in] none
 ** \return  none
 ** \note	
*****************************************************************************/
void ADCB_ClearAdjustErrorFlag(void);

/*****************************************************************************
 ** \brief	ADCB_EnableCompareInt
 **			ADCBȽж
 ** \param [in] none
 ** \return  none
 ** \note	ֱֻ֧Ƚ 0 
*****************************************************************************/
void ADCB_EnableCompareInt(void);
/*****************************************************************************
 ** \brief	ADCB_DisableCompareInt
 **			رADCBȽж
 ** \param [in] none
 ** \return  none
 ** \note	ֱֻ֧Ƚ 0 
*****************************************************************************/
void ADCB_DisableCompareInt(void);
/*****************************************************************************
 ** \brief	ADCB_GetCompareIntFlag
 **			ȡADCBȽжʹܲҲжϱ־λ
 ** \param [in] none
 ** \return  1:жʹܲҲж 0ж
 ** \note	ֱֻ֧Ƚ 0 
*****************************************************************************/
uint32_t ADCB_GetCompareIntFlag(void);
/*****************************************************************************
 ** \brief	ADCB_ClearCompareIntFlag
 **			ADCBȽжϱ־λ
 ** \param [in] none
 ** \return  none
 ** \note	ֱֻ֧Ƚ 0 
*****************************************************************************/
void ADCB_ClearCompareIntFlag(void);

/*****************************************************************************
 ** \brief	ADCB_EnableChannelInt
 **			ADCBͨnж
 ** \param [in]ChannelMask: ADCB_CH_0_MSK ~ ADCB_CH_30_MSK
 ** \return  none
 ** \note	
*****************************************************************************/
void ADCB_EnableChannelInt(uint32_t ChannelMask);
/*****************************************************************************
 ** \brief	ADCB_DisableChannelInt
 **			رADCBͨnж
 ** \param [in] ChannelMask: ADCB_CH_0_MSK ~ ADCB_CH_30_MSK
 ** \return  none
 ** \note	
*****************************************************************************/
void ADCB_DisableChannelInt(uint32_t ChannelMask);
/*****************************************************************************
 ** \brief	ADCB_GetChannelIntFlag
 **			ȡADCBͨnжʹܲҲжϱ־λ
 ** \param [in] Channel:ADCB_CH_0 ~ ADCB_CH_30
 ** \return  1:жʹܲҲж 0ж
 ** \note	
*****************************************************************************/
uint32_t ADCB_GetChannelIntFlag(uint32_t Channel);
/*****************************************************************************
 ** \brief	ADCB_ClearChannelIntFlag
 **			ADCBͨnжϱ־λ
 ** \param [in] Channel:ADCB_CH_0 ~ ADCB_CH_30
 ** \return  none
 ** \note	
*****************************************************************************/
void ADCB_ClearChannelIntFlag(uint32_t Channel);



#ifdef __cplusplus
}
#endif

#endif /* __ADCB_H_ */

