#ifndef _SPI_H_
#define _SPI_H_
#include "spi.h"
#include "CMS32F030.h"

/*----------------------------------------------------------------------------
 **EEPROM  M95256 
 **	
 ---------------------------------------------------------------------------*/
#define	M95256_WREN			0x06
#define M95256_WRDI			0x04
#define	M95256_RDSR			0x05
#define	M95256_WRSR			0x01
#define	M95256_READ			0x03
#define	M95256_WRITE		0x02
#define	M95256_RDID			0x83
#define	M95256_WRID			0x82
#define	M95256_RDLS			0x83
#define	M95256_LID			0x82


/*****************************************************************************/
/* Global function prototypes ('extern', definition in C source) */
/*****************************************************************************/
/***************************************************************************
 ** \brief	 SPI_Master_Mode
 **
 ** \param [in]  none   
 ** \return none
 ** \note
***************************************************************************/
void SPI_Master_Mode(void);

/***************************************************************************
 ** \brief	 SPI_M95256_Write
 **			 
 ** \param [in]  addr: 
 **				 buf:
 ** \return 
 ** \note
***************************************************************************/
void SPI_M95256_Write(uint32_t addr, uint32_t buf);
/***************************************************************************
 ** \brief	 SPI_M95256_Read_Data
 **			
** \param [in]  addr :   
 ** \return 8bit Data
 ** \note
***************************************************************************/
uint32_t SPI_M95256_Read_Data(uint32_t addr);

/***************************************************************************
 ** \brief	 SPI_M95256_Read_SFR
 **			
 ** \param [in]  cmd:	
 ** \return 8bit Data
 ** \note
***************************************************************************/
uint32_t  SPI_M95256_Read_SFR(uint32_t cmd);

void SPI_ConfigMaster(void);
void SPI_ConfigSlaver(void);


#endif
