/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/****************************************************************************/
/** \file demo_epwm.c
**
**	History:
**	
*****************************************************************************/
/****************************************************************************/
/*	include files
*****************************************************************************/
#include "demo_epwm.h"

/****************************************************************************/
/*	Local pre-processor symbols/macros('#define')
*****************************************************************************/

/****************************************************************************/
/*	Global variable definitions(declared in header file with 'extern')
*****************************************************************************/

/****************************************************************************/
/*	Local type definitions('typedef')
*****************************************************************************/

/****************************************************************************/
/*	Local variable  definitions('static')
*****************************************************************************/


/****************************************************************************/
/*	Local function prototypes('static')
*****************************************************************************/

/****************************************************************************/
/*	Function implementation - global ('extern') and local('static')
*****************************************************************************/

/*****************************************************************************
 ** \brief	EPWM_Config
 **			
 ** \param [in] none
 ** \return  none
 ** \note	
*****************************************************************************/
void EPWM_Config(void)
{
	/*
	(1)EPWMģʽ
	*/
	EPWM_ConfigRunMode(  EPWM_COUNT_DOWN 		| 			/*¼ģʽ(ض)*/
						 EPWM_OCU_SYMMETRIC 	|			/*Գģʽ*/
						 EPWM_WFG_INDEPENDENT   |			/*ģʽ*/
						 EPWM_OC_INDEPENDENT);				/*ģʽ*/
	/*
	(2)EPWMʱ
	*/
	SYS_EnablePeripheralClk(SYS_CLK_EPWM_MSK);				/*EPWMʱ*/
	
	EPWM_ConfigChannelClk( EPWM0, EPWM_CLK_DIV_1);			/*EPWM0ʱΪAPBʱӵ1Ƶ*/
	EPWM_ConfigChannelClk( EPWM1, EPWM_CLK_DIV_1);			/*EPWM1ʱΪAPBʱӵ1Ƶ*/
	EPWM_ConfigChannelClk( EPWM2, EPWM_CLK_DIV_1);			/*EPWM2ʱΪAPBʱӵ1Ƶ*/
	EPWM_ConfigChannelClk( EPWM3, EPWM_CLK_DIV_1);			/*EPWM3ʱΪAPBʱӵ1Ƶ*/


	EPWM_ConfigChannelPeriod(EPWM0,  2400);					/*EPWM0ͨ = 2400/Fepwm = 50us*/
	EPWM_ConfigChannelPeriod(EPWM1,  2400);					/*EPWM1ͨ = 2400/Fepwm = 50us*/
	EPWM_ConfigChannelPeriod(EPWM2,  2400);					/*EPWM2ͨ = 2400/Fepwm = 50us*/
	EPWM_ConfigChannelPeriod(EPWM3,  2400);					/*EPWM3ͨ = 2400/Fepwm = 50us*/


	EPWM_ConfigChannelSymDuty(EPWM0, 0);					/*EPWM0ͨռձ = 0%*/
	EPWM_ConfigChannelSymDuty(EPWM1, 480);					/*EPWM1ͨռձ = 20%*/	
	EPWM_ConfigChannelSymDuty(EPWM2, 960);					/*EPWM2ͨռձ = 40%*/	
	EPWM_ConfigChannelSymDuty(EPWM3, 1440);					/*EPWM3ͨռձ = 60%*/	
					

	/*
	(3)EPWM
	*/
	EPWM_DisableReverseOutput( EPWM_CH_0_MSK | EPWM_CH_1_MSK |
							   EPWM_CH_2_MSK | EPWM_CH_3_MSK );				/*رշ*/

	/*
	(4)EPWMطʽ
	*/
	EPWM_EnableAutoLoadMode(EPWM_CH_0_MSK | EPWM_CH_1_MSK |
							EPWM_CH_2_MSK | EPWM_CH_3_MSK);				/*ΪԶģʽ*/
	EPWM_ConfigLoadAndIntMode(EPWM0, EPWM_EACH_PERIOD_ZERO);			
	EPWM_ConfigLoadAndIntMode(EPWM1, EPWM_EACH_PERIOD_ZERO);
	EPWM_ConfigLoadAndIntMode(EPWM2, EPWM_EACH_PERIOD_ZERO);
	EPWM_ConfigLoadAndIntMode(EPWM3, EPWM_EACH_PERIOD_ZERO);		/*صΪÿڵ*/
	/*
	(5)EPWMɲ
	*/
	EPWM_AllBrakeDisable();

	/*
	(6)ж
	*/
	EPWM_EnableZeroInt(EPWM_CH_0_MSK);								/*ж*/		
	
	NVIC_EnableIRQ(EPWM_IRQn);
	/*
	(6)ȼ
	*/	
	NVIC_SetPriority(EPWM_IRQn,3);					/*ȼ0~3 0ߡ3*/
	
	/*
	(7)IO
	*/	
	SYS_SET_IOCFG(IOP47CFG, SYS_IOCFG_P47_EPWM0);		
	SYS_SET_IOCFG(IOP46CFG, SYS_IOCFG_P46_EPWM1);	
	SYS_SET_IOCFG(IOP45CFG, SYS_IOCFG_P45_EPWM2);	
	SYS_SET_IOCFG(IOP44CFG, SYS_IOCFG_P44_EPWM3);	



	EPWM_EnableChannelRemap(EPWM0, IPG0);				/*ʵӳ*/	
	EPWM_EnableChannelRemap(EPWM1, IPG2);
	EPWM_EnableChannelRemap(EPWM2, IPG3);
	EPWM_EnableChannelRemap(EPWM3, IPG1);


	EPWM_EnableOutput(EPWM_CH_0_MSK | EPWM_CH_1_MSK |
					  EPWM_CH_2_MSK | EPWM_CH_3_MSK );

	/*
	(8)EPWM
	*/		
	EPWM_Start(EPWM_CH_0_MSK | EPWM_CH_1_MSK |
			   EPWM_CH_2_MSK | EPWM_CH_3_MSK );
}


