/*******************************************************************************
* Copyright (C) 2019 China Micro Semiconductor Limited Company. All Rights Reserved.
*
* This software is owned and published by:
* CMS LLC, No 2609-10, Taurus Plaza, TaoyuanRoad, NanshanDistrict, Shenzhen, China.
*
* BY DOWNLOADING, INSTALLING OR USING THIS SOFTWARE, YOU AGREE TO BE BOUND
* BY ALL THE TERMS AND CONDITIONS OF THIS AGREEMENT.
*
* This software contains source code for use with CMS
* components. This software is licensed by CMS to be adapted only
* for use in systems utilizing CMS components. CMS shall not be
* responsible for misuse or illegal use of this software for devices not
* supported herein. CMS is providing this software "AS IS" and will
* not be responsible for issues arising from incorrect user implementation
* of the software.
*
* This software may be replicated in part or whole for the licensed use,
* with the restriction that this Disclaimer and Copyright notice must be
* included with each copy of this software, whether used in part or whole,
* at all times.
*/

/****************************************************************************/
/** \file main.c
**
**	History:
**	
*****************************************************************************/
/****************************************************************************/
/*	include files
*****************************************************************************/
#include "cms32m53xx.h"
#include "demo_i2c.h"

/****************************************************************************/
/*	Local pre-processor symbols/macros('#define')
*****************************************************************************/

/****************************************************************************/
/*	Global variable definitions(declared in header file with 'extern')
*****************************************************************************/
volatile	uint32_t value=0;
volatile	uint32_t datasize=0;
uint32_t 	array[10]={0};

/****************************************************************************/
/*	Local type definitions('typedef')
*****************************************************************************/

/****************************************************************************/
/*	Local variable  definitions('static')
*****************************************************************************/

/****************************************************************************/
/*	Local function prototypes('static')
*****************************************************************************/


/****************************************************************************/
/*	Function implementation - global ('extern') and local('static')
*****************************************************************************/

/*****************************************************************************
 ** \brief	 main
 **
 ** \param [in]  none   
 **
 ** \return 0
*****************************************************************************/
int main(void)
{			
 	SYS_DisableIOCFGProtect();			/*رIOCONFIGд*/
	SYS_DisableGPIO0Protect();			/*رGPIO0ؼĴд*/
	SYS_DisableGPIO1Protect();			/*رGPIO1ؼĴд*/
	SYS_DisableGPIO2Protect();			/*رGPIO2ؼĴд*/
	SYS_DisableGPIO3Protect();			/*رGPIO3ؼĴд*/
	SYS_DisableGPIO4Protect();			/*رGPIO4ؼĴд*/
	
	SYS_ConfigHSI(SYS_CLK_HSI_48M);		/*ڲʱΪ48Mhz*/
	SYS_EnableHSI();					/*ʱ*/
	SYS_ConfigAHBClock(SYS_CLK_SEL_HSI,SYS_CLK_DIV_1);	/*AHBʱΪʱӵ1Ƶ*/
	SYS_ConfigAPBClock(AHB_CLK_DIV_1);					/*APBʱΪAHBʱӵ1Ƶ*/
	SystemCoreClockUpdate();						/*ˢSystemCoreCLkSystemAPBClockֵ*/

	
	I2C_Master_Mode();								/*I2Cģʽ*/		

	/*DebugģʽʹãʽAT24C256I2CЭһ£ɲοAT24C256ֲ*/	
	At24c256_write_byte(0x10, 0x31);			/*д*/
	value = At24c256_read_byte(0x10);			/**/
	
	for(datasize =0; datasize<5; datasize++ )
	{
		At24c256_write_byte((0x11 + datasize), (0x32 + datasize));
	}
	datasize = 5;
	At24c256_read_str(0x11, array, datasize);	/**/
	while(1)
	{
		;
	}	
		
}


















